
/**
 * All the cacti in the current map
 */
array<CactusData@> cacti = {};


class CactusData {
    vec3 coords; // position of cactus in world
#if MP4
    nat3 worldcoords;
#endif
    CactusData(CGameCtnBlock@ block) {
        this.coords = GetCtnBlockMidpoint(block);
#if MP4
        this.worldcoords = block.Coord;
#endif
    }
    CactusData(CGameCtnAnchoredObject@ item) {
        this.coords = item.AbsolutePositionInMap;
#if MP4
        this.worldcoords = PosToCoord(item.AbsolutePositionInMap);
#endif
    }
    bool opEquals(CactusData@ cp) {
        return this is cp;
    }
}

