/*
 * by ArEyeses
 */

[Setting category="General" name="Show when driving"]
bool show = true;

[Setting category="General" name="Show in Editor" description="Show in any mode where you are not driving, such as map editor or replay editor"]
bool showEditor = true;

[Setting category="General" name="Dot size" min=2 max=64]
int dotSize = 7;

[Setting category="General" name="Show when UI hidden"]
bool showUIHidden = true;

[Setting category="General" name="Smaller dots with distance" description="Further cacti have smaller dots. Will never become too small to see"]
bool showDistance = true;

[Setting category="General" name="Use gradient colors"]
bool useGradientFill = true;

[Setting category="General" name="Single-color dots (small rendering speed increase)"]
bool lowDrawQuality = false;

// driving in map
bool inMap = false;
// mapping in editor
bool inEditor = false;

/**
 * The ID of the map whose cacti are currently in the arraya.
 */
string curMapId = "";

uint64 startTime;


// exit map, resets the current map and cacti lists
void reset() {
    curMapId = "";
    cacti = {};
    inMap = false;
    inEditor = false;

}

void Main() {
    while (true) {
        yield();
        startTime = Time::get_Now();

        if (!show && !showEditor) {continue;}
        
        if (GetApp().RootMap is null) {
            reset();
            continue;
        }

#if TMNEXT
        if (show) {
            CSmArenaClient@ playground = cast<CSmArenaClient>(GetApp().CurrentPlayground);
            if(playground !is null
                && playground.Arena !is null) {
                Update_InMap();
                continue;
            }
        }
#elif MP4
        if (show) {
            CTrackManiaRace@ playground = cast<CTrackManiaRace>(GetApp().CurrentPlayground);
            if(playground !is null &&
                playground.GameTerminals.Length > 0) {
                Update_InMap();
                continue;
            }

            CSmArenaClient@ playgroundSm = cast<CSmArenaClient>(GetApp().CurrentPlayground);
            if(playgroundSm !is null &&
                playgroundSm.GameTerminals.Length > 0) {
                Update_InMap();
                continue;
            }
        }
#endif

        // playground is null when loading in to map, so need to check editor exists (could be map or replay)
        if (GetApp().Editor is null) {
            reset();
            continue;
        } else if (showEditor) {
            Update_InEditor();
        }
        // continue;
    }
}
