
uint blocks_size = 0;
string lastBlockId = '';
string lastBlockType = '';
uint items_size = 0;
string lastItemId = '';

void Update_InEditor() {

    if ((!inEditor || hasChanged())) {
        reset(); // won't be called if returning from map to editor

        inEditor = true;

        Update_FromRootmap();

    }
}
void Update_InMap() {
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);

    if (!inMap && (curMapId != rootMap.IdName || GetApp().Editor !is null)) {
        // keep the previously-determined cacti data, unless in the map editor

        reset(); // won't be called before if in editor

        inMap = true;

        Update_FromRootmap();
    }
}

void Update_FromRootmap() {
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);

    curMapId = rootMap.IdName;

    blocks_size = rootMap.Blocks.Length;
    if (blocks_size > 0) {
        lastBlockId = rootMap.Blocks[rootMap.Blocks.Length-1].IdName;
        lastBlockType = rootMap.Blocks[rootMap.Blocks.Length-1].BlockModel.Name;
    } else {
        lastBlockId = '';
    }
    items_size = rootMap.AnchoredObjects.Length;
    if (items_size > 0) {
        lastItemId = rootMap.AnchoredObjects[rootMap.AnchoredObjects.Length-1].IdName;
    } else {
        lastItemId = '';
    }

    SetTitlepackBlockSize();
    for(uint i = 0; i < rootMap.Blocks.Length; i++) {
        if (rootMap.Blocks[i].BlockModel.Name.Contains('Cactus')) {

            cacti.InsertLast(CactusData(rootMap.Blocks[i]));
            if (Time::get_Now() - startTime > 20) {
                yield();
                startTime = Time::get_Now();
                if (rootMap is null || GetApp().RootMap !is rootMap) {
                    reset();
                    return;}
            }
        }
    }
    for(uint i = 0; i < rootMap.AnchoredObjects.Length; i++) {
        if (rootMap.AnchoredObjects[i].ItemModel.Name.Contains('Cactus') || rootMap.AnchoredObjects[i].ItemModel.Name == 'Summer' || rootMap.AnchoredObjects[i].ItemModel.Name == 'SummerPalmTree') {

            cacti.InsertLast(CactusData(rootMap.AnchoredObjects[i]));
            if (Time::get_Now() - startTime > 20) {
                yield();
                startTime = Time::get_Now();
                if (rootMap is null || GetApp().RootMap !is rootMap) {
                    reset();
                    return;}
            }
        }
    }
}

bool hasChanged() {
    CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);
    if (rootMap is null) {return true;}
    if (GetApp().Editor is null || cast<CGameCtnEditorFree>(GetApp().Editor) is null) {return false;}
    return !(blocks_size == rootMap.Blocks.Length && lastBlockId == rootMap.Blocks[rootMap.Blocks.Length-1].IdName && lastBlockType == rootMap.Blocks[rootMap.Blocks.Length-1].BlockModel.Name && items_size == rootMap.AnchoredObjects.Length && ((rootMap.AnchoredObjects.Length == 0 && lastItemId == '') || (rootMap.AnchoredObjects.Length > 0 && lastItemId == rootMap.AnchoredObjects[rootMap.AnchoredObjects.Length-1].IdName)));
}
